<template>
<div>
    <v-card class="ma-5 ">
    <div class="pa-3">
    <h2>จัดการสินค้า</h2>
    <v-btn large outlined color="info" class="my-3 " @click="addProduct()"> เพิ่มสินค้า <v-icon>mdi-basket-plus</v-icon></v-btn>
    </div>

    <v-simple-table>
    <template v-slot:default>
      <thead>
        <tr>
          <th class="text-left">
            ชื่อสินค้า
          </th>
          <th class="text-left">
            ราคา
          </th>
          <th class="text-left">
            ไซส์ (size)
          </th>
          <th class="text-left">
            รายละเอียด
          </th>
          <th class="text-left">
            จำนวน
          </th>
          <th class="text-left">
            จัดการ
          </th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="(data, index) in apidata.data" :key="index">
          <td>{{ data.product_name }}</td>
          <td>{{ data.price }}</td>
          <td>{{ data.detail.size }}</td>
          <td>{{ data.detail.description }}</td>
          <td>{{ data.amount }}</td>
          <td>
              <v-btn outlined color="info" class="mx-2" @click="editmode(data)">อัพเดท</v-btn>
              <v-btn outlined color="error" class="mx-2" @click="deletemode(data)">ลบ</v-btn>
          </td>
        </tr>
      </tbody>
    </template>
  </v-simple-table>
  </v-card>

  <v-dialog v-model="dialogedit" max-width="500px" >
      <v-card>
        <v-card-title class="justify-center">
          <span class="text-h5">{{savemode}}</span>
        </v-card-title>

        <v-card-text>
          <v-container>
            <v-row>
              <v-col cols="12" sm="6" md="6" >
                <v-text-field v-model="postdata.product_name" label="ชื่อสินค้า" ></v-text-field>
              </v-col>
              <v-col cols="12" sm="6" md="6" >
                <v-text-field v-model="postdata.price" label="ราคา" type="number"></v-text-field>
              </v-col>
              <v-col cols="12" sm="6" md="6" >
                <v-text-field v-model="postdata.amount" label="จำนวน" type="number"></v-text-field>
              </v-col>
              <v-col cols="12" sm="6" md="6" >
                <v-text-field v-model="postdata.detail.size" label="ไซส์" ></v-text-field>
              </v-col>
              <v-col cols="12" sm="12" md="12" >
                <v-text-field v-model="postdata.detail.description" label="รายละเอียด" ></v-text-field>
              </v-col>
              <v-col cols="12" sm="12" md="12" >
                <v-text-field v-model="postdata.img" label="รูปภาพ" ></v-text-field>
              </v-col>
            </v-row>
          </v-container>
        </v-card-text>

        <v-card-actions class="justify-center">
          <v-btn outlined color="green accent-3"  @click="saveProduct()" >บันทึก</v-btn>
          <v-btn outlined color="red darken-3"  @click="dialogedit = false" >ยกเลิก</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-dialog v-model="dialogDelete" max-width="500px">
      <v-card>
        <v-card-title class="text-h5">คุณแน่ใจว่าต้องการลบสินค้านี้หรือไม่?</v-card-title>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="red darken-1" text @click="deleteProduct()">ตกลง</v-btn>
          <v-btn color="blue darken-1" text @click="dialogDelete = false">ยกเลิก</v-btn>
          <v-spacer></v-spacer>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
export default {
  data () {
    return {
      id: '',
      apidata: [],
      dialogedit: false,
      dialogDelete: false,
      postdata: {
        product_name : '',
        price : '',
        amount : '',
        detail : {
            size : '',
            description : ''
        },
        img : ''
      },
      postdefault: {
        product_name : '',
        price : '',
        amount : '',
        detail : {
            size : '',
            description : ''
        },
        img : ''
      }
    }
  },
  created () {
    this.getProduct()
  },
  computed: {
    savemode () {
      return this.id === '' ? 'เพิ่มสินค้า' : 'อัพเดทสินค้า'
    }
  },
  methods: {
    addProduct () {
      this.id = ''
      this.postdata = Object.assign({}, this.postdefault)
      this.dialogedit = true
    },
    editmode (item) {
      this.id = item._id
      this.postdata = Object.assign({}, item)
      this.dialogedit = true
    },
    deletemode (item) {
      this.id = item._id
      this.dialogDelete = true
    },
    saveProduct  () {
      console.log(this.savemode)
      if (this.savemode === 'อัพเดทสินค้า') {
        this.updateProduct()
      } else this.createProduct()
    },
    getProduct () {
      this.axios.get('http://localhost:3000/products').then((response) => {
        this.apidata = response.data
      })
    },
    async createProduct () {
      try {
        const { data } = await this.axios.post('http://localhost:3000/products', this.postdata)
        alert(data.message)
        this.getProduct()
        this.postdata = Object.assign({}, this.postdefault)
        this.dialogedit = false
      } catch (error) {
        console.log(error.message)
      }
    },
    async updateProduct () {
      try {
        const { data } = await this.axios.put('http://localhost:3000/products/' + this.id, this.postdata)
        alert(data.message)
        this.getProduct()
        this.postdata = Object.assign({}, this.postdefault)
        this.dialogedit = false
      } catch (error) {
        console.log(error.message)
      }
    },
    async deleteProduct () {
      try {
        const { data } = await this.axios.delete('http://localhost:3000/products/' + this.id)
        console.log(data)
        alert(data.message)
        this.getProduct()
        this.id = ''
        this.dialogDelete = false
      } catch (error) {
        console.log(error.message)
      }
    }
  }
}
</script>

<style>

</style>
